OpenCV - Bug # 253: cvShowlmage() with Cocoa causes serious memory leak on Mac 10.6 x86_64

Status: Done Priority: High

Author: Ryan Lei Category: highgui-gui
Created: 2010-04-02 Assignee: Vadim Pisarevsky
Updated: 2012-08-16 Due date:

Affected version:

Difficulty:

Pull request:

Operating System:

HW Platform:

Description: Today | built r2968 by CMake with commands

<pre>
sudo cmake -G "Unix Makefiles" -D BUILD_NEW_PYTHON_SUPPORT=0FF -D BUILD_TESTS=OFF -D
WITH_CARBON=0OFF -D WITH_QUICKTIME=OFF .

sudo make -j8

sudo make install

</pre>

which gave QTKit and Cocoa support.

Then with the following simple webcam capturing code:
<pre>
int main() {
[[Iplimage]] *frame;
[[Ipllmage]] *resized;
/* Example 2-9: Input from a camera */
cvNamedWindow("USB Camera");
[[CvCapture]] *camera = cvCaptureFromCAM( 0 );
assert( camera != NULL );

while (true ) {
frame = cvQueryFrame( camera );
resized = cvCreatelmage(cvSize(800, 600), IPL_DEPTH_8U, 3);
cvResize(frame, resized);
cvShowlmage("USB Camera", resized);
0if (cvWaitKey( 10 ) == 32 ) break;

0cvReleaselmage(&resized);
}
cvReleaseCapture( &camera );
return 0;
}
</pre>
caused serious memory leak as in this [[youtube video]].
The variable resize does not matter with the memory leak, and cvReleaselmage(&frame) gives [[OpenCV]]
exceptions as indicated in the [[doc]].

The same source code runs WITHOUT memory leak with the library previously built with make_framework.sh
and r2492, giving [[QuickTime]] and Carbon support.
| think the problem lies in the file src/highgui/*cvcap_qgt.mm®*.
Associated revisions

2010-06-24 02:28 pm - Vadim Pisarevsky

fixed memory leaks in cocoa bindings (trac ticket #253). Thanks to N. Butko

2013-01-10 05:35 pm - Vadim Pisarevsky

Merge pull request #253 from Nerei:smart_operators_for_smart_ptr

History

2010-04-02 01:54 pm - Ryan Lei
btw, | think the key line is

<pre>

frame = cvQueryFrame( camera );
</pre>

, Which returns a pointer to an entire Iplimage.

2010-05-02 11:35 pm - anonymous -
Replying to [comment:1 ryanleitaiwan]:
> btw, | think the key line is

<pre>

> frame = cvQueryFrame( camera );
</pre>

>, which returns a pointer to an entire Iplimage.

| have made similar tests, it seems that the memory leak is in the cvShowlmage()

2010-06-07 01:14 pm - Giorgio B.

I've made a test too. The memory leak is very likely to be caused by cvShowlmage()

I'm working on Mac OS X 10.6.3 + [[OpenCV]] r3146 with Cocoa and QTKit.

Is anybody working on that? This problem is very frustrating! :(

Regards,
Giorgio

Replying to [comment:3 anonymous]:

> Replying to [comment:1 ryanleitaiwan]:

> > btw, | think the key line is

<pre>

> > frame = cvQueryFrame( camera );

</pre>

> >, which returns a pointer to an entire Iplimage.

>

> | have made similar tests, it seems that the memory leak is in the cvShowlmage()

>

2010-06-10 09:46 pm - Nicholas Butko

| am changing the summary to reflect the content of the thread (the problem is in cvShowlmage())

2010-06-13 10:42 am - anonymous -
FYI, same problem in new Python bindings; /samples/python/camera.py hogs over a GB in a matter of seconds. Commenting out the call to

cv.Showlmage makes the problem go away.
This is on on x86_64 OSX10.6 of course. Note that | used a regular build line of just:
cmake -G "Unix Makefiles"

...that is, no specific build options. Seems to be core.

2010-06-14 01:01 am - Nicholas Butko

| attached a patch that should fix the memory leak. There are also other miscellaneous fixes.

There is still some cleaning up that could be done on window_cocoa, but it should be lower priority. Please continue to report bugs if you see them.

2010-06-14 08:54 am - anonymous -

| just applied the patch to latest SVN, seems to run nicely. The memory leak has disappeared with the fix. Thank you!

2010-06-14 10:22 am - Ryan Lei

Cheers! It's finally fixed. Is this the status going to be changed to _closed_?

2010-06-14 10:23 am - Ryan Lei

Cheers! It's finally fixed. Is the status going to be changed to _closed_?

2010-06-14 06:53 pm - Nicholas Butko

- (deleted custom field) set to fixed

2010-06-14 07:13 pm - Brian Gerkey

- Status changed from Done to Cancelled

- (deleted custom field) deleted (fixed)

2010-06-14 07:13 pm - Brian Gerkey
- Status deleted (Cancelled)

2010-06-24 02:29 pm - Vadim Pisarevsky

- Status set to Done

- (deleted custom field) set to fixed

Thanks! The patch was applied in r3253

2010-11-13 04:44 pm - Ricardo Zilleruelo

- Status changed from Done to Cancelled

- (deleted custom field) deleted (fixed)

| still observe the memory leak.

The code below just display an image over and over again. This has a memory leak, around +1MB per second.

| compile the code linking to opencv svn trunk code. Rev: 3914.

g++ opencv_camera2.cpp -0 opencv_camera -L/Users/zeta/opencv/opencv/lib/ -lI/Users/zeta/opencv/opencv/include/opencv/ -lhighgui
#include "highgui.h"
int main(){
[[Iplimage]] *frame;
[[CvCapture]]* capture = cvCaptureFromCAM(CV_CAP_ANY);
cvNamedWindow("x",CV_WINDOW_AUTOSIZE);
frame = cvQueryFrame(capture);
while(1) cvShowImage("x",frame);

return 0O;

2010-11-13 07:17 pm - Nicholas Butko

- Status changed from Cancelled to Done

- (deleted custom field) set to worksforme

| tested the code, and there is no memory leak.

You are probably linking to the wrong library. The correct library is "opencv_highgui" and not "highgui".

I am using r3825, but | checked out r3914, and there are no differences that should cause a leak to reappear. The differences are almost negligible and
only affect windows platforms.

Here was my compile script:
g++ opencv_camera2.cpp -0 opencv_camera -L/usr/local/lib -lopencv_highgui -lI/usr/local/include/opencv

2012-08-16 03:34 pm - Andrey Kamaev
- Category changed from highgui-images to highgui-gui

Files

window_cocoa.patch 17.8 kB 2010-06-14 Nicholas Butko
